=== debian/changelog ===
waylandpp (1.0.1-1) unstable; urgency=medium

  * New upstream version 1.0.1
  * updated the debian patch

 -- Georges Khaznadar <georgesk@debian.org>  Thu, 14 Aug 2025 11:19:23 +0200
